Index: LMDZ4/trunk/libf/phylmd/thermcell.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 878)
@@ -1,14 +1,9 @@
-!
-! $Header$
-!
-
-      SUBROUTINE thermcell(ngrid,nlay,ptimestep
-     s                  ,pplay,pplev,pphi
+      SUBROUTINE calcul_sec(ngrid,nlay,ptimestep
+     s                  ,pplay,pplev,pphi,zlev
      s                  ,pu,pv,pt,po
-     s                  ,pduadj,pdvadj,pdtadj,pdoadj
-     s                  ,fm0,entr0
+     s                  ,zmax,wmax,zw2,lmix
 c    s                  ,pu_therm,pv_therm
      s                  ,r_aspect,l_mix,w2di,tho)
-      USE dimphy
+
       IMPLICIT NONE
 
@@ -18,11 +13,11 @@
 c   de "thermiques" explicitement representes
 c
-c   Reecriture a partir d'un listing papier à Habas, le 14/02/00
-c
-c   le thermique est suppose homogene et dissipe par melange avec
-c   son environnement. la longueur l_mix controle l'efficacite du
-c   melange
-c
-c   Le calcul du transport des differentes especes se fait en prenant
+c   Réécriture à partir d'un listing papier à Habas, le 14/02/00
+c
+c   le thermique est supposé homogène et dissipé par mélange avec
+c   son environnement. la longueur l_mix contrôle l'efficacité du
+c   mélange
+c
+c   Le calcul du transport des différentes espèces se fait en prenant
 c   en compte:
 c     1. un flux de masse montant
@@ -37,6 +32,6 @@
 c   -------------
 
-cym#include "dimensions.h"
-cym#include "dimphy.h"
+#include "dimensions.h"
+#include "dimphy.h"
 #include "YOMCST.h"
 
@@ -56,5 +51,5 @@
       save idetr
       data idetr/3/
-c$OMP THREADPRIVATE(idetr)
+
 c   local:
 c   ------
@@ -89,7 +84,6 @@
       real fracc(klon,klev+1)
       real zf,zf2
-      real,allocatable,save :: thetath2(:,:),wth2(:,:)
-c$OMP THREADPRIVATE(thetath2,wth2)
-cym      common/comtherm/thetath2,wth2
+      real thetath2(klon,klev),wth2(klon,klev)
+      common/comtherm/thetath2,wth2
 
       real count_time
@@ -98,5 +92,5 @@
       data isplit/0/
       save isplit
-c$OMP THREADPRIVATE(isplit)
+
       logical sorties
       real rho(klon,klev),rhobarz(klon,klev+1),masse(klon,klev)
@@ -116,14 +110,17 @@
       real fm(klon,klev+1),entr(klon,klev)
       real fmc(klon,klev+1)
-
+ 
 cCR:nouvelles variables
       real f_star(klon,klev+1),entr_star(klon,klev)
       real entr_star_tot(klon),entr_star2(klon)
+      real zalim(klon)
+      integer lalim(klon)
+      real norme(klon)
       real f(klon), f0(klon)
       real zlevinter(klon)
+      logical therm
       logical first
       data first /.false./
       save first
-c$OMP THREADPRIVATE(first)
 cRC
 
@@ -138,7 +135,5 @@
       save ncorrec
       data ncorrec/0/
-c$OMP THREADPRIVATE(ncorrec)
-      logical,save :: firstCall=.true.
-c$OMP THREADPRIVATE(firstCall)
+      
 c
 c-----------------------------------------------------------------------
@@ -146,11 +141,4 @@
 c   ---------------
 c
-      if (firstcall) then
-        allocate(thetath2(klon,klev),wth2(klon,klev))
-	thetath2(:,:)=0.
-	wth2(:,:)=0.
-	firstcall=.false.
-      endif
-      
        sorties=.true.
       IF(ngrid.NE.klon) THEN
@@ -165,5 +153,5 @@
 c   ---------------------------------------------------
 
-       print*,'0 OK convect8'
+c       print*,'0 OK convect8'
 
       DO 1010 l=1,nlay
@@ -178,5 +166,5 @@
 1010  CONTINUE
 
-       print*,'1 OK convect8'
+c       print*,'1 OK convect8'
 c                       --------------------
 c
@@ -291,13 +279,18 @@
 
 con ne considere que les premieres couches instables
+      therm=.false.
       do k=nlay-2,1,-1
          do ig=1,ngrid
             if (ztv(ig,k).gt.ztv(ig,k+1).and.
      s          ztv(ig,k+1).le.ztv(ig,k+2)) then
-               lentr(ig)=k
+               lentr(ig)=k+1
+               therm=.true.
             endif
           enddo
       enddo
-    
+climitation de la valeur du lentr
+c      do ig=1,ngrid
+c         lentr(ig)=min(5,lentr(ig))
+c      enddo
 c determination du lmin: couche d ou provient le thermique
       do ig=1,ngrid
@@ -309,4 +302,35 @@
                lmin(ig)=l-1
             endif
+         enddo
+      enddo
+cinitialisations
+      do ig=1,ngrid
+         zalim(ig)=0.
+         norme(ig)=0.
+         lalim(ig)=1
+      enddo
+      do k=1,klev-1
+         do ig=1,ngrid
+       zalim(ig)=zalim(ig)+zlev(ig,k)*MAX(0.,(ztv(ig,k)-ztv(ig,k+1))
+     s          /(zlev(ig,k+1)-zlev(ig,k)))
+c     s         *(zlev(ig,k+1)-zlev(ig,k))
+       norme(ig)=norme(ig)+MAX(0.,(ztv(ig,k)-ztv(ig,k+1))
+     s          /(zlev(ig,k+1)-zlev(ig,k)))
+c    s          *(zlev(ig,k+1)-zlev(ig,k))
+         enddo
+       enddo
+       do ig=1,ngrid
+          if (norme(ig).gt.1.e-10) then
+             zalim(ig)=max(10.*zalim(ig)/norme(ig),zlev(ig,2))
+c             zalim(ig)=min(zalim(ig),zlev(ig,lentr(ig)))
+          endif
+       enddo
+cdétermination du lalim correspondant
+      do k=1,klev-1
+         do ig=1,ngrid
+      if ((zalim(ig).gt.zlev(ig,k)).and.(zalim(ig).le.zlev(ig,k+1))) 
+     s   then
+         lalim(ig)=k
+      endif
          enddo
       enddo
@@ -316,11 +340,30 @@
          do ig=1,ngrid 
             if (ztv(ig,l).gt.ztv(ig,l+1).and.
-     s          l.ge.lmin(ig).and.l.le.lentr(ig)) then 
-                 entr_star(ig,l)=(ztv(ig,l)-ztv(ig,l+1))*
-     s                           (zlev(ig,l+1)-zlev(ig,l))
-            endif
-         enddo
-      enddo
-c pas de thermique si couches 1->5 stables
+     s          l.ge.lmin(ig).and.l.lt.lentr(ig)) then 
+                 entr_star(ig,l)=MAX((ztv(ig,l)-ztv(ig,l+1)),0.)
+c     s                           *(zlev(ig,l+1)-zlev(ig,l))
+     s                           *sqrt(zlev(ig,l+1))
+cautre def
+c                entr_star(ig,l)=zlev(ig,l+1)*(1.-(zlev(ig,l+1)
+c     s                         /zlev(ig,lentr(ig)+2)))**(3./2.)
+            endif
+         enddo
+      enddo
+cnouveau test
+c      if (therm) then
+      do l=1,klev-1
+         do ig=1,ngrid 
+            if (ztv(ig,l).gt.ztv(ig,l+1).and.
+     s          l.ge.lmin(ig).and.l.le.lalim(ig)
+     s          .and.zalim(ig).gt.1.e-10) then 
+c            if (l.le.lentr(ig)) then 
+c               entr_star(ig,l)=zlev(ig,l+1)*(1.-(zlev(ig,l+1)
+c     s                         /zalim(ig)))**(3./2.)
+c               write(10,*)zlev(ig,l),entr_star(ig,l)
+            endif
+         enddo
+      enddo
+c      endif
+c pas de thermique si couche 1 stable
       do ig=1,ngrid
          if (lmin(ig).gt.5) then
@@ -339,6 +382,16 @@
          enddo
       enddo
-c
-      print*,'fin calcul entr_star'
+c Calcul entrainement normalise
+      do ig=1,ngrid 
+         if (entr_star_tot(ig).gt.1.e-10) then
+c         do l=1,lentr(ig)
+          do l=1,klev
+cdef possibles pour entr_star: zdthetadz, dthetadz, zdtheta 
+            entr_star(ig,l)=entr_star(ig,l)/entr_star_tot(ig)
+         enddo
+         endif
+      enddo
+c
+c      print*,'fin calcul entr_star'
       do k=1,klev
          do ig=1,ngrid 
@@ -394,5 +447,5 @@
 ctest
                if (abs(zw2(ig,l+1)-zw2(ig,l)).lt.1e-10) then
-                  print*,'pb linter'
+c                  print*,'pb linter'
                endif
                linter(ig)=(l*(zw2(ig,l+1)-zw2(ig,l))
@@ -402,5 +455,5 @@
             else
                if (zw2(ig,l+1).lt.0.) then
-                  print*,'pb1 zw2<0'
+c                  print*,'pb1 zw2<0'
                endif
                wa_moy(ig,l+1)=sqrt(zw2(ig,l+1))
@@ -413,12 +466,14 @@
          enddo
       enddo
-      print*,'fin calcul zw2'
+c      print*,'fin calcul zw2'
 c
 c Calcul de la couche correspondant a la hauteur du thermique
       do ig=1,ngrid
          lmax(ig)=lentr(ig)
+c         lmax(ig)=lalim(ig)
       enddo
       do ig=1,ngrid
          do l=nlay,lentr(ig)+1,-1
+c         do l=nlay,lalim(ig)+1,-1
             if (zw2(ig,l).le.1.e-10) then
                lmax(ig)=l-1
@@ -426,9 +481,11 @@
          enddo
       enddo
-c pas de thermique si couches 1->5 stables
+c pas de thermique si couche 1 stable
       do ig=1,ngrid
          if (lmin(ig).gt.5) then
             lmax(ig)=1
             lmin(ig)=1
+            lentr(ig)=1
+            lalim(ig)=1
          endif
       enddo 
@@ -443,5 +500,5 @@
             if (l.le.lmax(ig)) then
                 if (zw2(ig,l).lt.0.)then
-                  print*,'pb2 zw2<0'
+c                  print*,'pb2 zw2<0'
                 endif
                 zw2(ig,l)=sqrt(zw2(ig,l))
@@ -465,7 +522,13 @@
        zmax(ig)=max(zmax(ig),zlevinter(ig)-zlev(ig,lmin(ig)))
       enddo
-
-      print*,'avant fermeture'
+      do ig=1,ngrid
+c      write(8,*)zmax(ig),lmax(ig),lentr(ig),lmin(ig)
+      enddo
+con stoppe après les calculs de zmax et wmax
+      RETURN
+
+c      print*,'avant fermeture'
 c Fermeture,determination de f
+cAttention! entrainement normalisé ou pas?
       do ig=1,ngrid
          entr_star2(ig)=0.
@@ -476,4 +539,5 @@
          else
              do k=lmin(ig),lentr(ig)
+c             do k=lmin(ig),lalim(ig) 
                 entr_star2(ig)=entr_star2(ig)+entr_star(ig,k)**2
      s                    /(rho(ig,k)*(zlev(ig,k+1)-zlev(ig,k)))
@@ -481,16 +545,18 @@
 c Nouvelle fermeture
              f(ig)=wmax(ig)/(max(500.,zmax(ig))*r_aspect
-     s             *entr_star2(ig))*entr_star_tot(ig)
+     s             *entr_star2(ig))
+c     s            *entr_star_tot(ig)
 ctest
 c             if (first) then
-c             f(ig)=f(ig)+(f0(ig)-f(ig))*exp(-ptimestep/zmax(ig)
-c     s             *wmax(ig))
+             f(ig)=f(ig)+(f0(ig)-f(ig))*exp(-ptimestep/zmax(ig)
+     s             *wmax(ig))
 c             endif
          endif
-c         f0(ig)=f(ig)
+         f0(ig)=f(ig)
 c         first=.true.
       enddo
-      print*,'apres fermeture'
-
+c      print*,'apres fermeture'
+con stoppe après la fermeture
+      RETURN
 c Calcul de l'entrainement
        do k=1,klev
@@ -499,4 +565,17 @@
          enddo
       enddo
+con stoppe après le calcul de entr
+c      RETURN
+cCR:test pour entrainer moins que la masse
+c       do ig=1,ngrid
+c          do l=1,lentr(ig)
+c             if ((entr(ig,l)*ptimestep).gt.(0.9*masse(ig,l))) then
+c                entr(ig,l+1)=entr(ig,l+1)+entr(ig,l)
+c     s                       -0.9*masse(ig,l)/ptimestep
+c                entr(ig,l)=0.9*masse(ig,l)/ptimestep
+c             endif
+c          enddo
+c       enddo
+cCR: fin test
 c Calcul des flux
       do ig=1,ngrid
@@ -516,5 +595,5 @@
 c   calcul de la largeur de chaque ascendance dans le cas conservatif.
 c   dans ce cas simple, on suppose que la largeur de l'ascendance provenant
-c   d'une couche est egale a la hauteur de la couche alimentante.
+c   d'une couche est égale à la hauteur de la couche alimentante.
 c   La vitesse maximale dans l'ascendance est aussi prise comme estimation
 c   de la vitesse d'entrainement horizontal dans la couche alimentante.
@@ -536,7 +615,14 @@
 c  cette option est finalement en dur.
                   if ((l_mix*zlev(ig,l)).lt.0.)then
-                   print*,'pb l_mix*zlev<0'
+c                   print*,'pb l_mix*zlev<0'
                   endif
+cCR: test: nouvelle def de lambda
+c                  larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
+                  if (zw2(ig,l).gt.1.e-10) then
+                  larg_detr(ig,l)=sqrt((l_mix/zw2(ig,l))*zlev(ig,l))
+                  else
                   larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
+                  endif
+cRC
 c              else if (idetr.eq.1) then
 c                 larg_detr(ig,l)=larg_cons(ig,l)
@@ -555,5 +641,5 @@
 c      print*,'10 OK convect8'
 c     print*,'WA2 ',wa_moy
-c   calcul de la fraction de la maille concerne  par l'ascendance en tenant
+c   calcul de la fraction de la maille concernée par l'ascendance en tenant
 c   compte de l'epluchage du thermique.
 c
@@ -578,5 +664,5 @@
             else
             zmix(ig)=zlev(ig,lmix(ig))
-            print*,'pb zmix'
+c            print*,'pb zmix'
             endif
          else 
@@ -657,5 +743,5 @@
       enddo
       
-      print*,'fin calcul fraca'
+c      print*,'fin calcul fraca'
 c      print*,'11 OK convect8'
 c     print*,'Ea3 ',wa_moy
@@ -700,5 +786,5 @@
       enddo
 
-      print*,'12 OK convect8'
+c      print*,'12 OK convect8'
 c     print*,'WA4 ',wa_moy
 cc------------------------------------------------------------------
@@ -760,5 +846,6 @@
             detr(ig,l)=fm(ig,l)+entr(ig,l)-fm(ig,l+1)
             if (detr(ig,l).lt.0.) then
-                entr(ig,l)=entr(ig,l)-detr(ig,l)
+c                entr(ig,l)=entr(ig,l)-detr(ig,l)
+                fm(ig,l+1)=fm(ig,l)+entr(ig,l)
                 detr(ig,l)=0.
 c     print*,'WARNING !!! detrainement negatif ',ig,l
@@ -831,5 +918,5 @@
 c      enddo
 
-      print*,'14 OK convect8'
+c      print*,'14 OK convect8'
 c------------------------------------------------------------------
 c   Calculs pour les sorties
@@ -901,5 +988,5 @@
 #endif
 123   continue
-c#define troisD
+#define troisD
 #ifdef troisD
 c       if (sorties) then
@@ -988,407 +1075,185 @@
 c     if(wa_moy(1,4).gt.1.e-10) stop
 
-      print*,'19 OK convect8'
+c      print*,'19 OK convect8'
       return
       end
 
-      subroutine dqthermcell(ngrid,nlay,ptimestep,fm,entr,masse
-     .    ,q,dq,qa)
-      use dimphy
-      implicit none
-
-c=======================================================================
-c
-c   Calcul du transport verticale dans la couche limite en presence
-c   de "thermiques" explicitement representes
-c   calcul du dq/dt une fois qu'on connait les ascendances
-c
-c=======================================================================
-
-cym#include "dimensions.h"
-cym#include "dimphy.h"
-
-      integer ngrid,nlay
-
-      real ptimestep
-      real masse(ngrid,nlay),fm(ngrid,nlay+1)
-      real entr(ngrid,nlay)
-      real q(ngrid,nlay)
-      real dq(ngrid,nlay)
-
-      real qa(klon,klev),detr(klon,klev),wqd(klon,klev+1)
-
-      integer ig,k
-
-c   calcul du detrainement
-
-      do k=1,nlay
-         do ig=1,ngrid
-            detr(ig,k)=fm(ig,k)-fm(ig,k+1)+entr(ig,k)
-         enddo
-      enddo
-
-c   calcul de la valeur dans les ascendances
-      do ig=1,ngrid
-         qa(ig,1)=q(ig,1)
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-            if ((fm(ig,k+1)+detr(ig,k))*ptimestep.gt.
-     s         1.e-5*masse(ig,k)) then
-               qa(ig,k)=(fm(ig,k)*qa(ig,k-1)+entr(ig,k)*q(ig,k))
-     s         /(fm(ig,k+1)+detr(ig,k))
+      SUBROUTINE fermeture_seche(ngrid,nlay
+     s                ,pplay,pplev,pphi,zlev,rhobarz,f0,zpspsk
+     s                ,alim_star,zh,zo,lentr,lmin,nu_min,nu_max,r_aspect
+     s                ,zmax,wmax)
+
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+
+      INTEGER ngrid,nlay
+      REAL pplay(ngrid,nlay),pplev(ngrid,nlay+1)
+      real pphi(ngrid,nlay)
+      real zlev(klon,klev+1)
+      real alim_star(klon,klev)
+      real f0(klon)
+      integer lentr(klon)
+      integer lmin(klon)
+      real zmax(klon)
+      real wmax(klon)
+      real nu_min
+      real nu_max
+      real r_aspect
+      real rhobarz(klon,klev+1)
+      REAL zh(klon,klev)
+      real zo(klon,klev)
+      real zpspsk(klon,klev)
+
+      integer ig,l
+
+      real f_star(klon,klev+1)
+      real detr_star(klon,klev)
+      real entr_star(klon,klev)
+      real zw2(klon,klev+1)
+      real linter(klon)
+      integer lmix(klon)
+      integer lmax(klon)
+      real zlevinter(klon)
+      real wa_moy(klon,klev+1)
+      real wmaxa(klon)
+      REAL ztv(klon,klev)
+      REAL ztva(klon,klev)
+      real nu(klon,klev)
+      real zmax0_sec(klon)
+      save zmax0_sec
+
+      do l=1,nlay
+         do ig=1,ngrid
+      ztv(ig,l)=zh(ig,l)/zpspsk(ig,l)
+      ztv(ig,l)=ztv(ig,l)*(1.+RETV*zo(ig,l))
+         enddo
+      enddo
+      do l=1,nlay-2
+         do ig=1,ngrid
+            if (ztv(ig,l).gt.ztv(ig,l+1)
+     s         .and.alim_star(ig,l).gt.1.e-10
+     s         .and.zw2(ig,l).lt.1e-10) then
+               f_star(ig,l+1)=alim_star(ig,l)
+ctest:calcul de dteta
+               zw2(ig,l+1)=2.*RG*(ztv(ig,l)-ztv(ig,l+1))/ztv(ig,l+1)
+     s                     *(zlev(ig,l+1)-zlev(ig,l))
+     s                     *0.4*pphi(ig,l)/(pphi(ig,l+1)-pphi(ig,l))
+            else if ((zw2(ig,l).ge.1e-10).and.
+     s         (f_star(ig,l)+alim_star(ig,l)).gt.1.e-10) then
+cestimation du detrainement a partir de la geometrie du pas precedent
+ctests sur la definition du detr
+             nu(ig,l)=(nu_min+nu_max)/2.
+     s         *(1.-(nu_max-nu_min)/(nu_max+nu_min)
+     s  *tanh((((ztva(ig,l-1)-ztv(ig,l))/ztv(ig,l))/0.0005)))
+         
+             detr_star(ig,l)=rhobarz(ig,l)
+     s                      *sqrt(zw2(ig,l)) 
+     s                       /(r_aspect*zmax0_sec(ig))*
+c     s                       /(r_aspect*zmax0(ig))*
+     s                      (sqrt(nu(ig,l)*zlev(ig,l+1)
+     s                /sqrt(zw2(ig,l)))
+     s                     -sqrt(nu(ig,l)*zlev(ig,l)
+     s                /sqrt(zw2(ig,l))))
+         detr_star(ig,l)=detr_star(ig,l)/f0(ig)
+         if ((detr_star(ig,l)).gt.f_star(ig,l)) then
+              detr_star(ig,l)=f_star(ig,l)
+         endif
+         entr_star(ig,l)=0.9*detr_star(ig,l)
+             if ((l.lt.lentr(ig))) then
+                 entr_star(ig,l)=0.
+c                 detr_star(ig,l)=0.
+             endif 
+            print*,'ok detr_star'
+cprise en compte du detrainement dans le calcul du flux
+             f_star(ig,l+1)=f_star(ig,l)+alim_star(ig,l)+entr_star(ig,l)
+     s                      -detr_star(ig,l)
+ctest sur le signe de f_star
+       if ((f_star(ig,l+1)+detr_star(ig,l)).gt.1.e-10) then 
+cAM on melange Tl et qt du thermique
+          ztva(ig,l)=(f_star(ig,l)*ztva(ig,l-1)+(entr_star(ig,l)
+     s                    +alim_star(ig,l))
+     s                    *ztv(ig,l))/(f_star(ig,l+1)+detr_star(ig,l))
+               zw2(ig,l+1)=zw2(ig,l)*(f_star(ig,l)
+     s                     /(f_star(ig,l+1)+detr_star(ig,l)))**2+
+     s                     2.*RG*(ztva(ig,l)-ztv(ig,l))/ztv(ig,l)
+     s                     *(zlev(ig,l+1)-zlev(ig,l))
+            endif
+        endif
+c
+            if (zw2(ig,l+1).lt.0.) then 
+               linter(ig)=(l*(zw2(ig,l+1)-zw2(ig,l))
+     s           -zw2(ig,l))/(zw2(ig,l+1)-zw2(ig,l))
+               zw2(ig,l+1)=0.
+               print*,'linter=',linter(ig)
             else
-               qa(ig,k)=q(ig,k)
-            endif
-         enddo
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-c             wqd(ig,k)=fm(ig,k)*0.5*(q(ig,k-1)+q(ig,k))
-            wqd(ig,k)=fm(ig,k)*q(ig,k)
-         enddo
-      enddo
-      do ig=1,ngrid
-         wqd(ig,1)=0.
-         wqd(ig,nlay+1)=0.
-      enddo
-
-      do k=1,nlay
-         do ig=1,ngrid
-            dq(ig,k)=(detr(ig,k)*qa(ig,k)-entr(ig,k)*q(ig,k)
-     s               -wqd(ig,k)+wqd(ig,k+1))
-     s               /masse(ig,k)
-         enddo
-      enddo
-
-      return
-      end
-      subroutine dvthermcell(ngrid,nlay,ptimestep,fm,entr,masse
-     .    ,fraca,larga
-     .    ,u,v,du,dv,ua,va)
-       use dimphy
-      implicit none
-
-c=======================================================================
-c
-c   Calcul du transport verticale dans la couche limite en presence
-c   de "thermiques" explicitement representes
-c   calcul du dq/dt une fois qu'on connait les ascendances
-c
-c=======================================================================
-
-cym#include "dimensions.h"
-cym#include "dimphy.h"
-
-      integer ngrid,nlay
-
-      real ptimestep
-      real masse(ngrid,nlay),fm(ngrid,nlay+1)
-      real fraca(ngrid,nlay+1)
-      real larga(ngrid)
-      real entr(ngrid,nlay)
-      real u(ngrid,nlay)
-      real ua(ngrid,nlay)
-      real du(ngrid,nlay)
-      real v(ngrid,nlay)
-      real va(ngrid,nlay)
-      real dv(ngrid,nlay)
-
-      real qa(klon,klev),detr(klon,klev)
-      real wvd(klon,klev+1),wud(klon,klev+1)
-      real gamma0,gamma(klon,klev+1)
-      real dua,dva
-      integer iter
-
-      integer ig,k
-
-c   calcul du detrainement
-
-      do k=1,nlay
-         do ig=1,ngrid
-            detr(ig,k)=fm(ig,k)-fm(ig,k+1)+entr(ig,k)
-         enddo
-      enddo
-
-c   calcul de la valeur dans les ascendances
-      do ig=1,ngrid
-         ua(ig,1)=u(ig,1)
-         va(ig,1)=v(ig,1)
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-            if ((fm(ig,k+1)+detr(ig,k))*ptimestep.gt.
-     s         1.e-5*masse(ig,k)) then
-c   On itere sur la valeur du coeff de freinage.
-c              gamma0=rho(ig,k)*(zlev(ig,k+1)-zlev(ig,k))
-               gamma0=masse(ig,k)
-     s         *sqrt( 0.5*(fraca(ig,k+1)+fraca(ig,k)) )
-     s         *0.5/larga(ig)
-c              gamma0=0.
-c   la premiere fois on multiplie le coefficient de freinage
-c   par le module du vent dans la couche en dessous.
-               dua=ua(ig,k-1)-u(ig,k-1)
-               dva=va(ig,k-1)-v(ig,k-1)
-               do iter=1,5
-                  gamma(ig,k)=gamma0*sqrt(dua**2+dva**2)
-                  ua(ig,k)=(fm(ig,k)*ua(ig,k-1)
-     s               +(entr(ig,k)+gamma(ig,k))*u(ig,k))
-     s               /(fm(ig,k+1)+detr(ig,k)+gamma(ig,k))
-                  va(ig,k)=(fm(ig,k)*va(ig,k-1)
-     s               +(entr(ig,k)+gamma(ig,k))*v(ig,k))
-     s               /(fm(ig,k+1)+detr(ig,k)+gamma(ig,k))
-c                 print*,k,ua(ig,k),va(ig,k),u(ig,k),v(ig,k),dua,dva
-                  dua=ua(ig,k)-u(ig,k)
-                  dva=va(ig,k)-v(ig,k)
-               enddo
+               wa_moy(ig,l+1)=sqrt(zw2(ig,l+1))
+            endif
+            if (wa_moy(ig,l+1).gt.wmaxa(ig)) then
+c   lmix est le niveau de la couche ou w (wa_moy) est maximum
+               lmix(ig)=l+1
+               wmaxa(ig)=wa_moy(ig,l+1)
+            endif
+         enddo
+      enddo
+      print*,'fin calcul zw2'
+c
+c Calcul de la couche correspondant a la hauteur du thermique
+      do ig=1,ngrid
+         lmax(ig)=lentr(ig)
+      enddo
+      do ig=1,ngrid
+         do l=nlay,lentr(ig)+1,-1
+            if (zw2(ig,l).le.1.e-10) then
+               lmax(ig)=l-1
+            endif
+         enddo
+      enddo
+c pas de thermique si couche 1 stable
+      do ig=1,ngrid
+         if (lmin(ig).gt.1) then
+            lmax(ig)=1
+             lmin(ig)=1
+             lentr(ig)=1
+         endif
+      enddo 
+c    
+c Determination de zw2 max
+      do ig=1,ngrid
+         wmax(ig)=0.
+      enddo
+
+      do l=1,nlay
+         do ig=1,ngrid
+            if (l.le.lmax(ig)) then
+                if (zw2(ig,l).lt.0.)then
+                  print*,'pb2 zw2<0'
+                endif
+                zw2(ig,l)=sqrt(zw2(ig,l))
+                wmax(ig)=max(wmax(ig),zw2(ig,l))
             else
-               ua(ig,k)=u(ig,k)
-               va(ig,k)=v(ig,k)
-               gamma(ig,k)=0.
-            endif
-         enddo
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-            wud(ig,k)=fm(ig,k)*u(ig,k)
-            wvd(ig,k)=fm(ig,k)*v(ig,k)
-         enddo
-      enddo
-      do ig=1,ngrid
-         wud(ig,1)=0.
-         wud(ig,nlay+1)=0.
-         wvd(ig,1)=0.
-         wvd(ig,nlay+1)=0.
-      enddo
-
-      do k=1,nlay
-         do ig=1,ngrid
-            du(ig,k)=((detr(ig,k)+gamma(ig,k))*ua(ig,k)
-     s               -(entr(ig,k)+gamma(ig,k))*u(ig,k)
-     s               -wud(ig,k)+wud(ig,k+1))
-     s               /masse(ig,k)
-            dv(ig,k)=((detr(ig,k)+gamma(ig,k))*va(ig,k)
-     s               -(entr(ig,k)+gamma(ig,k))*v(ig,k)
-     s               -wvd(ig,k)+wvd(ig,k+1))
-     s               /masse(ig,k)
-         enddo
-      enddo
-
-      return
-      end
-      subroutine dqthermcell2(ngrid,nlay,ptimestep,fm,entr,masse,frac
-     .    ,q,dq,qa)
-      use dimphy
-      implicit none
-
-c=======================================================================
-c
-c   Calcul du transport verticale dans la couche limite en presence
-c   de "thermiques" explicitement representes
-c   calcul du dq/dt une fois qu'on connait les ascendances
-c
-c=======================================================================
-
-cym#include "dimensions.h"
-cym#include "dimphy.h"
-
-      integer ngrid,nlay
-
-      real ptimestep
-      real masse(ngrid,nlay),fm(ngrid,nlay+1)
-      real entr(ngrid,nlay),frac(ngrid,nlay)
-      real q(ngrid,nlay)
-      real dq(ngrid,nlay)
-
-      real qa(klon,klev),detr(klon,klev),wqd(klon,klev+1)
-      real qe(klon,klev),zf,zf2
-
-      integer ig,k
-
-c   calcul du detrainement
-
-      do k=1,nlay
-         do ig=1,ngrid
-            detr(ig,k)=fm(ig,k)-fm(ig,k+1)+entr(ig,k)
-         enddo
-      enddo
-
-c   calcul de la valeur dans les ascendances
-      do ig=1,ngrid
-         qa(ig,1)=q(ig,1)
-         qe(ig,1)=q(ig,1)
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-            if ((fm(ig,k+1)+detr(ig,k))*ptimestep.gt.
-     s         1.e-5*masse(ig,k)) then
-               zf=0.5*(frac(ig,k)+frac(ig,k+1))
-               zf2=1./(1.-zf)
-               qa(ig,k)=(fm(ig,k)*qa(ig,k-1)+zf2*entr(ig,k)*q(ig,k))
-     s         /(fm(ig,k+1)+detr(ig,k)+entr(ig,k)*zf*zf2)
-               qe(ig,k)=(q(ig,k)-zf*qa(ig,k))*zf2
-            else
-               qa(ig,k)=q(ig,k)
-               qe(ig,k)=q(ig,k)
-            endif
-         enddo
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-c             wqd(ig,k)=fm(ig,k)*0.5*(q(ig,k-1)+q(ig,k))
-            wqd(ig,k)=fm(ig,k)*qe(ig,k)
-         enddo
-      enddo
-      do ig=1,ngrid
-         wqd(ig,1)=0.
-         wqd(ig,nlay+1)=0.
-      enddo
-
-      do k=1,nlay
-         do ig=1,ngrid
-            dq(ig,k)=(detr(ig,k)*qa(ig,k)-entr(ig,k)*qe(ig,k)
-     s               -wqd(ig,k)+wqd(ig,k+1))
-     s               /masse(ig,k)
-         enddo
-      enddo
-
-      return
-      end
-      subroutine dvthermcell2(ngrid,nlay,ptimestep,fm,entr,masse
-     .    ,fraca,larga
-     .    ,u,v,du,dv,ua,va)
-      use dimphy
-      implicit none
-
-c=======================================================================
-c
-c   Calcul du transport verticale dans la couche limite en presence
-c   de "thermiques" explicitement representes
-c   calcul du dq/dt une fois qu'on connait les ascendances
-c
-c=======================================================================
-
-cym#include "dimensions.h"
-cym#include "dimphy.h"
-
-      integer ngrid,nlay
-
-      real ptimestep
-      real masse(ngrid,nlay),fm(ngrid,nlay+1)
-      real fraca(ngrid,nlay+1)
-      real larga(ngrid)
-      real entr(ngrid,nlay)
-      real u(ngrid,nlay)
-      real ua(ngrid,nlay)
-      real du(ngrid,nlay)
-      real v(ngrid,nlay)
-      real va(ngrid,nlay)
-      real dv(ngrid,nlay)
-
-      real qa(klon,klev),detr(klon,klev),zf,zf2
-      real wvd(klon,klev+1),wud(klon,klev+1)
-      real gamma0,gamma(klon,klev+1)
-      real ue(klon,klev),ve(klon,klev)
-      real dua,dva
-      integer iter
-
-      integer ig,k
-
-c   calcul du detrainement
-
-      do k=1,nlay
-         do ig=1,ngrid
-            detr(ig,k)=fm(ig,k)-fm(ig,k+1)+entr(ig,k)
-         enddo
-      enddo
-
-c   calcul de la valeur dans les ascendances
-      do ig=1,ngrid
-         ua(ig,1)=u(ig,1)
-         va(ig,1)=v(ig,1)
-         ue(ig,1)=u(ig,1)
-         ve(ig,1)=v(ig,1)
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-            if ((fm(ig,k+1)+detr(ig,k))*ptimestep.gt.
-     s         1.e-5*masse(ig,k)) then
-c   On itere sur la valeur du coeff de freinage.
-c              gamma0=rho(ig,k)*(zlev(ig,k+1)-zlev(ig,k))
-               gamma0=masse(ig,k)
-     s         *sqrt( 0.5*(fraca(ig,k+1)+fraca(ig,k)) )
-     s         *0.5/larga(ig)
-     s         *1.
-c    s         *0.5
-c              gamma0=0.
-               zf=0.5*(fraca(ig,k)+fraca(ig,k+1))
-               zf=0.
-               zf2=1./(1.-zf)
-c   la premiere fois on multiplie le coefficient de freinage
-c   par le module du vent dans la couche en dessous.
-               dua=ua(ig,k-1)-u(ig,k-1)
-               dva=va(ig,k-1)-v(ig,k-1)
-               do iter=1,5
-c   On choisit une relaxation lineaire.
-                  gamma(ig,k)=gamma0
-c   On choisit une relaxation quadratique.
-                  gamma(ig,k)=gamma0*sqrt(dua**2+dva**2)
-                  ua(ig,k)=(fm(ig,k)*ua(ig,k-1)
-     s               +(zf2*entr(ig,k)+gamma(ig,k))*u(ig,k))
-     s               /(fm(ig,k+1)+detr(ig,k)+entr(ig,k)*zf*zf2
-     s                 +gamma(ig,k))
-                  va(ig,k)=(fm(ig,k)*va(ig,k-1)
-     s               +(zf2*entr(ig,k)+gamma(ig,k))*v(ig,k))
-     s               /(fm(ig,k+1)+detr(ig,k)+entr(ig,k)*zf*zf2
-     s                 +gamma(ig,k))
-c                 print*,k,ua(ig,k),va(ig,k),u(ig,k),v(ig,k),dua,dva
-                  dua=ua(ig,k)-u(ig,k)
-                  dva=va(ig,k)-v(ig,k)
-                  ue(ig,k)=(u(ig,k)-zf*ua(ig,k))*zf2
-                  ve(ig,k)=(v(ig,k)-zf*va(ig,k))*zf2
-               enddo
-            else
-               ua(ig,k)=u(ig,k)
-               va(ig,k)=v(ig,k)
-               ue(ig,k)=u(ig,k)
-               ve(ig,k)=v(ig,k)
-               gamma(ig,k)=0.
-            endif
-         enddo
-      enddo
-
-      do k=2,nlay
-         do ig=1,ngrid
-            wud(ig,k)=fm(ig,k)*ue(ig,k)
-            wvd(ig,k)=fm(ig,k)*ve(ig,k)
-         enddo
-      enddo
-      do ig=1,ngrid
-         wud(ig,1)=0.
-         wud(ig,nlay+1)=0.
-         wvd(ig,1)=0.
-         wvd(ig,nlay+1)=0.
-      enddo
-
-      do k=1,nlay
-         do ig=1,ngrid
-            du(ig,k)=((detr(ig,k)+gamma(ig,k))*ua(ig,k)
-     s               -(entr(ig,k)+gamma(ig,k))*ue(ig,k)
-     s               -wud(ig,k)+wud(ig,k+1))
-     s               /masse(ig,k)
-            dv(ig,k)=((detr(ig,k)+gamma(ig,k))*va(ig,k)
-     s               -(entr(ig,k)+gamma(ig,k))*ve(ig,k)
-     s               -wvd(ig,k)+wvd(ig,k+1))
-     s               /masse(ig,k)
-         enddo
-      enddo
-
-      return
-      end
+                 zw2(ig,l)=0.
+            endif
+          enddo
+      enddo
+
+c   Longueur caracteristique correspondant a la hauteur des thermiques.
+      do  ig=1,ngrid
+         zmax(ig)=0.
+         zlevinter(ig)=zlev(ig,1)
+      enddo
+      do  ig=1,ngrid
+c calcul de zlevinter
+          zlevinter(ig)=(zlev(ig,lmax(ig)+1)-zlev(ig,lmax(ig)))*
+     s    linter(ig)+zlev(ig,lmax(ig))-lmax(ig)*(zlev(ig,lmax(ig)+1)
+     s    -zlev(ig,lmax(ig)))
+cpour le cas ou on prend tjs lmin=1
+c       zmax(ig)=max(zmax(ig),zlevinter(ig)-zlev(ig,lmin(ig)))
+       zmax(ig)=max(zmax(ig),zlevinter(ig)-zlev(ig,1))
+       zmax0_sec(ig)=zmax(ig)
+      enddo
+       
+      RETURN
+      END
Index: LMDZ4/trunk/libf/phylmd/thermcell.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell.h	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/thermcell.h	(revision 878)
@@ -1,13 +1,8 @@
-!
-! $Header$
-!
-
       integer iflag_thermals,nsplit_thermals
       real r_aspect_thermals,l_mix_thermals,tho_thermals
       integer w2di_thermals,isplit
 
-      common/ctherm/iflag_thermals,nsplit_thermals
-     s              ,r_aspect_thermals,l_mix_thermals,tho_thermals
-     s              ,w2di_thermals
+      common/ctherm1/iflag_thermals,nsplit_thermals
+      common/ctherm2/r_aspect_thermals,l_mix_thermals,tho_thermals
+      common/ctherm3/w2di_thermals
 
-c$OMP THREADPRIVATE(/ctherm/)
